﻿'Test of the ADC in the IO-Warrior56 V2.0 
'12th June 2018, Franz Peter Zantis
Option Explicit On
Option Strict On

Public Class Form1
    Dim iohandle As Integer
    Dim ioread(7) As Byte
    Dim iowrite(7) As Byte
    Dim ioadusettings(63) As Byte
    Dim ioadudata(63) As Byte
    Dim SPIsettings(63) As Byte
    Dim SPIsend(63) As Byte
    Dim SPIread(63) As Byte
    Dim retint As Integer
    Dim value_VJ6 As UInt16
    Dim value_IJ8 As UInt16
    Dim value_VJ10 As UInt16
    Dim value_VJ8 As UInt16
    Dim spgJ6a(100) As Double   'Array für die Spannungswerte am Anschluss J6
    Dim spgj8a(100) As Double   'Array für die Spannungswerte am Anschluss J8
    Dim stromj8a(100) As Double 'Array für die Stromwerte am Anschluss J8
    Dim spgj10a(100) As Double  'Array für die Spannungswerte am Anschluss J10
    Dim wertezaehler As Integer

    Dim spgJ6max As Double
    Dim stromJ8max As Double
    Dim spgJ10max As Double
    Dim spgJ8max As Double
    Dim spgJ6min As Double
    Dim stromJ8min As Double
    Dim spgJ10min As Double
    Dim spgJ8min As Double

    Dim Spgeingabe As Double    'Wertübernahme für die gewünschte Spannung an J8
    Dim DauWert As UShort       'Wert an den DAU für die Spannungsausgabe an J8

    Dim StopFlag As Boolean

    Dim Dauwertarray(1) As Byte



    Private Sub BtnStart_Click(sender As System.Object, e As System.EventArgs) Handles BtnStart.Click
        StopFlag = False
        Do Until StopFlag = True
            ioadudata(0) = &H1D
            retint = IowKitRead(iohandle, 1, ioadudata(0), 64)
            value_VJ6 = CUShort(ioadudata(2) * 256 + ioadudata(1))
            value_IJ8 = CUShort(ioadudata(4) * 256 + ioadudata(3))
            value_VJ10 = CUShort(ioadudata(6) * 256 + ioadudata(5))
            value_VJ8 = CUShort(ioadudata(8) * 256 + ioadudata(7))

            spgJ6a(wertezaehler) = value_VJ6
            spgj8a(wertezaehler) = value_VJ8
            stromj8a(wertezaehler) = value_IJ8
            spgj10a(wertezaehler) = value_VJ10

            wertezaehler = wertezaehler + 1
            If wertezaehler > 100 Then
                wertezaehler = 0
            End If

            spgJ6max = spgJ6a.Max() * (4.16 / 2 ^ 14) * (5 / 4.16) 'Spannung am Anschluss J6
            spgJ6min = spgJ6a.Min() * (4.16 / 2 ^ 14) * (5 / 4.16)
            Me.TxBxJ6Spg.Text = Format(spgJ6max, "#0.000")
            Me.TxBxJ6Spgmin.Text = Format(spgJ6min, "#0.000")

            stromJ8max = stromj8a.Max() * (4.16 / 2 ^ 14)      'Strom aus dem Anschluss J8
            stromJ8min = stromj8a.Min() * (4.16 / 2 ^ 14)
            Me.TxBxJ8Strom.Text = Format(stromJ8max, "#0.000")
            Me.TxBxJ8Strommin.Text = Format(stromJ8min, "#0.000")

            spgJ10max = spgj10a.Max() * (4.16 / 2 ^ 14) * (10 / 4.16)  'Spannung am Anschluss J10
            spgJ10min = spgj10a.Min() * (4.16 / 2 ^ 14) * (10 / 4.16)
            Me.TxBxSpgJ10.Text = Format(spgJ10max, "#0.000")
            Me.TxBxJ10min.Text = Format(spgJ10min, "#0.000")

            spgJ8max = spgj8a.Max() * (4.16 / 2 ^ 14) * (12 / 4.16)    'Spannung am Anschluss J8
            spgJ8min = spgj8a.Min() * (4.16 / 2 ^ 14) * (12 / 4.16)
            Me.TxBxJ8Spg.Text = Format(spgJ8max, "#0.000")
            Me.TxBxJ8Spgmin.Text = Format(spgJ8min, "#0.000")

            Application.DoEvents()
        Loop

    End Sub

    Private Sub Form1_FormClosed(sender As Object, e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        StopFlag = True
        IowKitCloseDevice(iohandle) 'Schließen zu Zugriffs auf den IO-Warrior56
    End Sub

    Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        iohandle = IowKitOpenDevice()
        If iohandle = 0 Then
            MessageBox.Show("Hardware nicht angeschlossen!", "ERROR")
            End
        End If

        ioadusettings(0) = &H1C     'Kennung für ADU-Betrieb
        ioadusettings(1) = 1        'ADU-Aktivieren
        ioadusettings(2) = 4        'Kanal
        ioadusettings(3) = 7        'Referenz (Gnd.. 4,16)
        ioadusettings(4) = 0        'Bypass
        retint = IowKitWrite(iohandle, 1, ioadusettings(0), 64) 'Settings für den ADU setzen

        iowrite(0) = 0
        iowrite(1) = 255    'Port 0 hochohmig schalten
        iowrite(2) = 255    'Port 1 hochohmig schalten
        iowrite(3) = 255    'Port 2 hochohmig schalten
        iowrite(4) = 255    'Port 3 hochohmig schalten
        iowrite(5) = 255    'Port 4 hochohmig schalten
        iowrite(6) = 255    'Port 5 hochohmig schalten
        iowrite(7) = 255    'Port 6 hochohmig schalten
        retint = IowKitWrite(iohandle, 0, iowrite(0), 8)
    End Sub

    Private Sub BtnStop_Click(sender As System.Object, e As System.EventArgs) Handles BtnStop.Click
        StopFlag = True
    End Sub

    Private Sub BtnAusgangspg_Click(sender As System.Object, e As System.EventArgs) Handles BtnAusgangspg.Click
        Spgeingabe = CDbl(Me.TxBxSpgeingabe.Text)
        DauWert = CUShort(4095 / 12 * Spgeingabe)
        Dauwertarray = SeparateHiByteLoByte(DauWert)
        Dauwertarray(1) = SetBit(Dauwertarray(1), 4)
        Dauwertarray(1) = ClearBit(Dauwertarray(1), 5)
        Dauwertarray(1) = SetBit(Dauwertarray(1), 6)
        Dauwertarray(1) = ClearBit(Dauwertarray(1), 7)

        SPIsettings(0) = 8
        SPIsettings(1) = 1
        SPIsettings(2) = 0
        SPIsettings(3) = 250
        retint = IowKitWrite(iohandle, 1, SPIsettings(0), 64) 'SPI-Bus einstellen

        iowrite(6) = ClearBit(iowrite(6), 7)                'ChipSelect für DAU
        retint = IowKitWrite(iohandle, 0, iowrite(0), 8)

        SPIsend(0) = 9                                      'Spannungsausgabe über SPI an DAU
        SPIsend(1) = 2
        SPIsend(2) = 0
        SPIsend(3) = Dauwertarray(1)
        SPIsend(4) = Dauwertarray(0)
        retint = IowKitWrite(iohandle, 1, SPIsend(0), 64)
        retint = IowKitRead(iohandle, 1, SPIread(0), 64)

        iowrite(6) = SetBit(iowrite(6), 7)                  'ChipSelect zurücksetzen
        retint = IowKitWrite(iohandle, 0, iowrite(0), 8)
    End Sub
End Class
